#include <sys/socket.h>

#define WINGATE 23
#define SOCKS4PORT 1080
#define SOCKS5PORT 1080
#define socktimeout 10
#define longtime 3000

#define MAXLEN          512

/**********************************************************/
/* BotServ Database */
typedef struct botinfo_ BotInfo;

struct botinfo_ {
        BotInfo *next, *prev;
        char *nick;             /* Bot Nickname*/
        char *user;             /* bot user name */
        char *host;             /* bot hostname */
        char *real;             /* bot real name */
        char *bmaster;          /* Whois this bot master */
	short flags;
        time_t created;
};

/***********************************************************/
/* Bot Flags */
#define BI_MASTER  0x00000001 /* Only master can assign it */
#define BI_USER    0x00000002 /* Open for every one */
#define BI_TEMP    0x00000004 /* A ChanOP bot */

